var gaze = require('gaze')
var coffee = require('coffee-script')
var fs = require('fs')
var path = require('path')

function doCafeCompile(filepath, opts) {
    var options = {
        bare: opts.bare || false
    };
    var content = '',
        jsText = '',
        dirname = path.dirname(filepath),
        filename = path.basename(filepath),
        extname = path.extname(filename),
        jsFileName = filename.replace(new RegExp('' + extname + '$', 'g'), '.js'),
        jsFilePath = path.resolve(dirname, jsFileName);

    var flag = true;
    try {
        content = fs.readFileSync(filepath, 'utf8')
        jsText = coffee.compile(content, options);
    } catch(e) {
        var message = [
            'COMPILE EXCEPTION: check ' + filepath + '\r\nor run cmd: coffee -c ' + filepath + ' (...copy me)',
            'ERROR: ' + e.message,
            'LINE: ' + e.location.first_line ,//+ '——' + e.location.last_line,  
            'COLUMN: ' + e.location.first_column + '\r\n-----end-------\r\n'//+ '——' + e.location.last_column  
        ].join('\r\n');
        process.send({
            type: 'error',
            msg: message
        });
        flag = false
    }
    if(flag) {
        fs.writeFile(jsFilePath, jsText, function(err) {
            var d= new Date()
            process.send({
                type:'success',
                msg: d.toLocaleTimeString() + " " +jsFilePath + ' created'
            });
        });
    }
}

process.on('message', function(config) {
    gaze(config.src || [], function() {
        var wacthedMap = this.watched()
        for(var wa in wacthedMap) {
           var pathArr = wacthedMap[wa]
           for (var i = pathArr.length - 1; i >= 0; i--) {
               if (/\.coffee$/.test(pathArr[i])) {
                    doCafeCompile(pathArr[i], config.options)
               }
           };
        }
        //console.log(this.watched())
        this.on('changed', function(filepath) {
            doCafeCompile(filepath, config.options)
        });
    });
})